﻿using C1.WPF.Grid;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;

namespace ConditionalCellFormatting
{
    public class UserCellFactory : GridCellFactory
    {

        public override object GetCellContentType(GridCellType cellType, GridCellRange range)
        {
            double val;
            if (range.Column == 3 && cellType == GridCellType.Cell)
            {
                if (Double.TryParse(Grid[range.Row, 2].ToString(), out val))
                {
                    if (val > 200)
                    {
                        return typeof(CheckBox);
                    }
                    else
                    {
                        return typeof(TextBlock);
                    }
                }
            }
            return base.GetCellContentType(cellType, range);
        }
        public override FrameworkElement CreateCellContent(GridCellType cellType, GridCellRange range, object cellContentType)
        {
            double val;
            if (range.Column == 3 && cellType == GridCellType.Cell)
            {
                if (Double.TryParse(Grid[range.Row, 2].ToString(), out val))
                {
                    if (val > 200)
                    {
                        var chk = new CheckBox();
                        chk.Content = "Check";
                        return chk;
                    }
                    else
                    {
                        var txt = new TextBlock();
                        txt.Text = "TextBox";
                        return txt;
                    }
                }
            }
            return base.CreateCellContent(cellType, range, cellContentType);
        }

        public override void BindCellContent(GridCellType cellType, GridCellRange range, FrameworkElement cellContent)
        {
            base.BindCellContent(cellType, range, cellContent);
            if (cellType == GridCellType.Cell && range.Column == 3)
            {
                if (cellContent is TextBlock currCell &&
                    Grid.Rows[range.Row].DataItem is Product dataItem)
                {
                    currCell.Text = "TextBlock";
                }

            }
        }

        public override void UnbindCellContent(GridCellType cellType, GridCellRange range, FrameworkElement cellContent)
        {
            base.UnbindCellContent(cellType, range, cellContent);
            if (cellType == GridCellType.Cell && range.Column == 3)
            {
                if (cellContent is TextBlock currCell &&
                    Grid.Rows[range.Row].DataItem is Product dataItem)
                {
                    currCell.Text = "TextBlock";
                }

            }
        }
    }
}
